{*
 *  PCCOM Commu. Library V2.0   By DECISION-COMPUTER CO.,LTD.     1993
 *}

unit PCCOM115;

interface

uses
   Dos;

const
{*
 * function number
 *}
   _COMINIT        =      $00;
   _COMSEND        =      $01;
   _COMRECV        =      $02;
   _COMSTAT        =      $03;
   _COMACTIVE      =      $04;
   _COMSETDTR      =      $06;
   _COMPURGERXBUF  =      $0A;
   _COMPEEK        =      $0C;
   _COMSETFLOW     =      $0F;
   _COMRXBLK       =      $18;
   _COMTXBLK       =      $19;
   _COMSETBREAK    =      $1A;
   _COMINFO        =      $1B;

   _COMBUFSTAT     =      $30;
   _COMSETPORT     =      $31;
   _COMSETVECTOR   =      $32;
   _COMSETACTIVE   =      $33;
   _COMSETMCR      =      $34;
   _COMGETPARAM    =      $35;
   _COMGETMCR      =      $36;
   _COMGETFC       =      $37;
   _COMGETSETS     =      $38;
   _COMGETSETINFO  =      $39;
   _COMGETPORTS    =      $3A;
   _COMDETECTPORT  =      $3B;
   _COMGETPORTINFO =      $3C;
   _COMRXOFF       =      $3D;
   _COMRXON        =      $3E;
   _COMSETTIMEOUT  =      $3F;
   _COMGETTIMEOUT  =      $40;

{*
 * line control
 *}
   B600            =      600;
   B1200           =     1200;
   B2400           =     2400;
   B4800           =     4800;
   B9600           =     9600;
   B38400          =    38400;
   B56000          =    56000;
   B115200         =   115200;
   CS5             =      5;
   CS6             =      6;
   CS7             =      7;
   CS8             =      8;
   ST1             =      1;
   ST2             =      2;
   PNONE           =      0;
   PODD            =      1;
   PEVEN           =      2;
   ACTIVE          =      1;
   INACTIVE        =      0;

   XON             =      17;
   XOFF            =      19;

{*
 *  status for serial port (function 1,2,3)
 *}
   S_CTS           =       $0010;
   S_DSR           =       $0020;
   S_DCD           =       $0080;
   S_RDA           =       $0100;
   S_THRE          =       $2000;
   S_TSRE          =       $4000;
   S_TIMEOUT       =       $8000;


{*
 *  modem control
 *}
   M_DTR           =       $01;
   M_RTS           =       $02;
   M_OUT1          =       $04;
   M_OUT2          =       $08;
   M_LOOP          =       $10;


{*
 *  flow control
 *}
   F_XONXOFF       =       $09;
   F_RTSCTS        =       $02;

{*
 *  get status
 *}
   GS_TIMEOUT      =       0;
   GS_BUFSTAT      =       1;
   GS_DCD          =       2;
   GS_DSR          =       3;
   GS_CTS          =       4;
   GS_DTR          =       5;
   GS_RTS          =       6;
   GS_ACTIVE       =       7;
   GS_VER          =       8;
   GS_OFULL        =       9;
   GS_BAUD         =       10;
   GS_FLOW         =       11;


type

{*
 *  fossil driver information
 *}
   FOSSIL_INFO = record
      size    : word;
      majver  : byte;
      minver  : byte;
      idofs   : word;
      idseg   : word;
      ibufr   : word;
      ifree   : word;
      obufr   : word;
      ofree   : word;
      swidth  : byte;
      sheight : byte;
      baud    : byte;
   end;

{*
 * information about one pccom set
 *}
   BiosComSet_t = record
      irq        : byte;
      portno     : word;
      groupno    : word;
      whichgroup : word;

      group : array [0..7] of
         record
            base   : word;
            vector : word;
            active : byte;
            portno : byte;
         end
   end;

   BiosComPort_t = record
      addr      : word;
      baud      : word;
      lcr       : byte;
      mcr       : byte;
      fc        : byte;
      rx_qsz    : word;
      rx_qfree  : word;
      rx_enable : byte;
      tx_enable : byte;
   end;

var
   info        : FOSSIL_INFO;

function  cominit(portno : integer; baud : longint; db, parity, sb : word) : integer;
function  comtxch(portno : integer; c : char) : integer;
function  comrxch(portno : integer; var c : char) : byte;
function  comstat(portno : integer) : integer;
function  comactive(portno : integer) : boolean;
procedure comsetDTR(portno : integer; dtr : integer);
procedure compurgerxbuf(portno : integer);
function  compeek(portno : integer) : integer;
procedure comsetflow(portno, flow : integer);
function  comrxblk(portno : integer; p : pointer; size : integer) : integer;
function  comtxblk(portno : integer; p : pointer; size : integer) : integer;
procedure combreak(portno, brk : integer);
function  cominstalled(portno : integer) : boolean;
function  comtxs(portno : integer; s : string) : integer;
function  comrxs(portno : integer; var s : string) : integer;
function  combufstat(portno : integer) : integer;
procedure comsetport(portno, addr : integer);
procedure comsetvector(portno, addr : integer);
procedure comsetactive(portno : integer; active : byte);
procedure comsetMCR(portno : integer; mcr : byte);
function  comgetparam(portno : integer) : byte;
procedure comgetinfo(portno : integer; var baud : word; var db, parity, sb : integer);
function  comgetMCR(portno : integer) : byte;
function  comgetFC(portno : integer) : byte;
function  comgetsets : integer;
procedure comgetsetinfo(portno : integer; var BiosComSet : BiosComSet_t);
function  comgetports : integer;
function  comdetectport(portno : integer) : boolean;
procedure comgetportinfo(portno : integer; var BiosComPort : BiosComPort_t);
procedure comrxoff(portno : integer);
procedure comrxon(portno : integer);
procedure comsettimeout(portno : integer; timeout : word);
function  comgettimeout(portno : integer) : word;


implementation

{*
 *      func :  set communication parameters
 *
 *      input :
 *              portno  : port number   0 .. 64
 *              baud    : baud rate     600, 1200, 2400, 4800, 9600, 38400, 56000, 115200
 *              db      : data bits     5, 6, 7, 8
 *              parity  : parity bit    0 : nonparity, 1 : odd parity, 3 : even parity
 *              sb      : stop bits     0 : 1 bit, 1 : 2 bits
 *      output :
 *              sts     : port status
 *}
function cominit(portno : integer; baud : longint; db, parity, sb : word) : integer;
var
   cmd : byte;
   reg : registers;

begin


if baud=B115200 then
         cmd := $20
         else
if baud=B56000  then
         cmd := $00
         else
if baud=B38400  then
         cmd := $E0
         else
if baud=B9600   then
         cmd := $C0
         else
if baud=B4800   then
         cmd := $A0
         else
if baud=B2400   then
         cmd := $80
         else
if baud=B1200   then
         cmd := $60
         else
if baud=B600    then
         cmd := $40
         else
         exit;


   case parity of
      PNONE :                  {non parity}
         cmd := cmd or $00;
      PODD :                   {odd parity}
         cmd := cmd or $04;
      PEVEN :                  {even parity}
         cmd := cmd or $0C;
      else
         exit;
   end;

   case db of
      CS5 :
         cmd := cmd or $00;
      CS6 :
         cmd := cmd or $01;
      CS7 :
         cmd := cmd or $02;
      CS8 :
         cmd := cmd or $03;
      else
         exit;
   end;

   case (sb) of
      ST1 :
         cmd := cmd or $00;
      ST2 :
         cmd := cmd or $04;
      else
         exit;
   end;

   reg.dx := portno;
   reg.ah := _COMINIT;
   reg.al := cmd;
   intr($14, reg);

   cominit := reg.ax;
end;

{*
 *      func : Transmit character and wait
 *
 *      input :
 *              portno  : port number
 *              c       : character transmitted
 *      output :
 *              sts     : port status
 *}
function comtxch(portno : integer; c : char) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSEND;
   reg.al := byte(c);
   intr($14, reg);

   comtxch := reg.ax;
end;

{*
 *      func : Get received character with wait
 *
 *      input :
 *              portno  : port number
 *      output :
 *              c       : input character
 *              sts     : port status
 *}
function comrxch(portno : integer; var c : char) : byte;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMRECV;
   intr($14, reg);
   c := char(reg.al);

   comrxch := reg.ah;
end;

{*
 *      func : return serial port status
 *
 *      input :
 *              portno  : port number
 *      output :
 *              sts     : port status
 *}
function comstat(portno : integer) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSTAT;
   intr($14, reg);

   comstat := reg.ax;
end;

function comactive(portno : integer) : boolean;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMACTIVE;
   intr($14, reg);

   comactive := reg.ax = $1954;
end;

procedure comsetDTR(portno : integer; dtr : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETDTR;
   reg.al := dtr;
   intr($14, reg);
end;

procedure compurgerxbuf(portno : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMPURGERXBUF;
   intr($14, reg);
end;

function compeek(portno : integer) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMPEEK;
   intr($14, reg);

   compeek := reg.ax;
end;

procedure comsetflow(portno, flow : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETFLOW;
   reg.al := flow;
   intr($14, reg);
end;

function comrxblk(portno : integer; p : pointer; size : integer) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMRXBLK;
   reg.cx := size;
   reg.di := ofs(p^);
   reg.es := seg(p^);
   intr($14, reg);
   comrxblk := reg.ax;
end;

function comtxblk(portno : integer; p : pointer; size : integer) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMTXBLK;
   reg.cx := size;
   reg.di := ofs(p^);
   reg.es := seg(p^);
   intr($14, reg);
   comtxblk := reg.ax;
end;

procedure combreak(portno, brk : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETBREAK;
   reg.al := brk;
   intr($14, reg);
end;

function cominstalled(portno : integer) : boolean;
var
   reg : registers;

begin
   info.majver := 0;
   reg.dx := portno;
   reg.ah := _COMINFO;
   reg.cx := sizeof(info);
   reg.di := ofs(info);
   reg.es := seg(info);
   intr($14, reg);

   cominstalled := info.majver >= 5;
end;

function comtxs(portno : integer; s : string) : integer;
var
   reg  : registers;
   stat : integer;
   i    : integer;

begin
   stat := 0;
   for i := 1 to ord(s[0]) do
      stat := stat or comtxch(portno, char(s[i]));

   comtxs := stat;
end;

function comrxs(portno : integer; var s : string) : integer;
var
   ch   : char;
   stat : integer;

begin
   s := '';
   repeat
      stat := comrxch(portno, ch);
      if (stat <> $80) and (ch <> chr(13)) then
         s := s + ch;
   until (ch = chr(13));

   comrxs := stat;
end;

function combufstat(portno : integer) : integer;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMBUFSTAT;
   intr($14, reg);

   combufstat := reg.cx;
end;

procedure comsetport(portno, addr : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETPORT;
   reg.bx := addr;

   intr($14, reg);
end;

procedure comsetvector(portno, addr : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETVECTOR;
   reg.bx := addr;
   intr($14, reg);
end;

procedure comsetactive(portno : integer; active : byte);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETACTIVE;
   reg.al := byte(active);
   intr($14, reg);
end;

procedure comsetMCR(portno : integer; mcr : byte);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETMCR;
   reg.al := mcr;
   intr($14, reg);
end;

function comgetparam(portno : integer) : byte;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETPARAM;
   intr($14, reg);

   comgetparam := reg.al;
end;

procedure comgetinfo(portno : integer; var baud : word; var db, parity, sb : integer);
const
   b : array[0..7] of longint = (
          B56000, B115200, B600, B1200, B2400, B4800, B9600, B38400
   );
   d : array[0..3] of integer = (
          CS5, CS6, CS7, CS8
   );
   s : array[0..1] of integer = (
          ST1, ST2
   );
   p : array[0..3] of integer = (
          PNONE, PODD, PNONE, PEVEN
   );

var
   r, n : byte;

begin
   r := comgetparam(portno);
   n := (r shr 5) and 7;
   baud := b[n];
   n := (r shr 3) and 3;
   parity := p[n];
   n := (r shr 2) and 1;
   sb := s[n];
   n := r and 3;
   db := d[n];
end;

function comgetMCR(portno : integer) : byte;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETMCR;
   intr($14, reg);

   comgetMCR := reg.al;
end;

function comgetFC(portno : integer) : byte;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETFC;
   intr($14, reg);

   comgetFC := reg.al;
end;

function comgetsets : integer;
var
   reg : registers;

begin
   reg.ah := _COMGETSETS;
   intr($14, reg);

   comgetsets := reg.ax;
end;

procedure comgetsetinfo(portno : integer; var BiosComSet : BiosComSet_t);
var
   reg :  registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETSETINFO;
   reg.di := ofs(BiosComSet);
   reg.es := seg(BiosComSet);
   intr($14, reg);
end;

function comgetports : integer;
var
   reg : registers;

begin
   reg.ah := _COMGETPORTS;
   intr($14, reg);

   comgetports := reg.ax;
end;

function comdetectport(portno : integer) : boolean;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMDETECTPORT;
   intr($14, reg);

   comdetectport := reg.ax = $55AA;
end;

procedure comgetportinfo(portno : integer; var BiosComPort : BiosComPort_t);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETPORTINFO;
   reg.di := ofs(BiosComPort);
   reg.es := seg(BiosComPort);
   intr($14, reg);
end;

procedure comrxoff(portno : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMRXOFF;
   intr($14, reg);
end;

procedure comrxon(portno : integer);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMRXON;
   intr($14, reg);
end;

procedure comsettimeout(portno : integer; timeout : word);
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMSETTIMEOUT;
   reg.cx := timeout;
   intr($14, reg);
end;

function comgettimeout(portno : integer) : word;
var
   reg : registers;

begin
   reg.dx := portno;
   reg.ah := _COMGETTIMEOUT;
   intr($14, reg);

   comgettimeout := reg.cx;
end;

end.