program ASCII_TERMINAL;

uses
   Crt;
var
   ff       : file;
   tch, rch : char;
   res      : integer;
   s        : string;

begin
   if ParamCount <> 1 then
   begin
      writeln('Usage : ascterm [devicename] ');
      writeln('< [input file] > [output file]');
      writeln('Example :');
      writeln('   ascterm com1');
      writeln('   ascterm com8 > abc.doc');
      writeln('   ascterm mydriver < abc.doc');
      halt(1);
   end;

   s := paramstr(1);
   assign(ff, paramstr(1));
   {$I-}
   reset(ff, 1);
   {$I+}
   if (IOResult <> 0) then
   begin
       writeln('No such device.');
       halt(2);
   end;

   writeln('SERIAL DRIVER Communication ascii terminal V1.00');
   writeln('Type ^Z to stop communication.');

   repeat
      while not keypressed do
      begin
         blockread(ff, rch,1 , res);
         if res > 0 then write(rch);
      end;

      tch := ReadKey;
      if tch <> #26 then blockwrite(ff, tch, 1);
   until tch = #26;

   close(ff);
end.
