{the PCCOM unit contains all the PCCOM library functions,
the PCDIAGM1 unit contains the procedure for the direct
hardware loopback test}
uses crt,dos,pcdiagm1,pccom115;

label finish;

var
   data:byte;
   response,response2:char;
   result:integer;
   counter3:integer;

{***********************************************************************}
{
NOTE: This same program must be executed on the remote computer simultaneously
with this computer.

This is the procedure that tests the computer to computer communication.
When the procedure is executed it sends a continous signal in the form of
the character 'S' to the remote computer then waits for the remote computer
to send its own signal. When it receives the signal from the remote computer
it would be now ready to receive any data that the remote computer sends.
At the same time it is ready to accept any keyboard input from the user
then sends this data to the remote computer.}

procedure test_computer_to_computer;
var
   portno,ia,ib,ic,id:integer;
   rdata,sdata:char;

begin
clrscr;
textcolor(14+blink);gotoxy(25,2);
writeln('D E C I S I O N    P R O D U C T S');
textcolor(11);gotoxy(30,3);
writeln('Computer to Computer Test');
for ia:=1 to 15 do
    begin
         textcolor(7);
         gotoxy(ia,5);writeln('Enter the COM port that would Send/Receive the data: ');
         textcolor(0);
         gotoxy(ia,5);writeln('Enter the COM port that would Send/Receive the data: ');
    end;
textcolor(7);
{ask the user on which COM port the communication must be established}
         gotoxy(ia,5);write('Enter the COM port that would Send/Receive the data: ');
readln(portno);




{initialize the specified COM port}
cominit(portno,B9600,CS8,PNONE,ST1);

{this is a standard to enable the proper communication of the computer;
in hardware terms the COMSETMCR(portno,8), enables the OUT2 signal of the
corresponding port. See hardware manual of the UART IC for more description. }
comsetmcr(portno,8);

{this is to clear the receiver buffer of the specified port for any garbage data}
compurgerxbuf(portno);
gotoxy(2,9);writeln('Data being Send !!!');
gotoxy(2,10);Writeln('------------------------------------------------------------------------------');
gotoxy(2,18);writeln('Data being Read !!!');
gotoxy(2,19);Writeln('------------------------------------------------------------------------------');
textcolor(4+blink);
gotoxy(2,7);writeln('Waiting for Remote Computer to respond !!!');

repeat

      {this is the signal transmitted to ask a request for communication}
      comtxch(portno,'S');

      {receive any request from the remote pc}
      comrxch(portno,rdata);
      delay(100);
until (keypressed) or (rdata='S');

{if the remote computer also sends a request for communication then
we start communicating }
if rdata='S' then
   begin
        textcolor(0);
        gotoxy(2,7);writeln('Waiting for Remote Computer to respond !!!');
        textcolor(15);
        gotoxy(2,7);writeln('You may now type your Message !!!');

        {clear again the receive buffer of the specified port}
        compurgerxbuf(portno);
        ia:=2;
        ib:=2;
        ic:=11;
        id:=20;
        repeat
              if ia=79 then
              begin
                   ia:=2;
                   if ic=18 then ic:=11 else ic:=ic+1;
              end;
              if ib=79 then
              begin
                   ib:=2;
                   if id=24 then id:=20 else id:=id+1;
              end;
              repeat

                    {this is to check if there are any pending data in the
                    receive buffer, the command below returns the number
                    of data still in the receive buffer}
                    result:=combufstat(portno);
              until (keypressed) or (result<>0);
              if keypressed then
              begin
                   sdata:=readkey;
                   if sdata <> #27 then
                   begin

                        {transmit the data the user wish to send}
                        comtxch(portno,sdata);
                        gotoxy(ia,ic);write(sdata);
                        ia:=ia+1;
                   end;
              end;
              if (result<>0) then
              begin

                   {get the data in the receive buffer, then display it}
                   comrxch(portno,rdata);
                   gotoxy(ib,id);write(rdata);
                   ib:=ib+1;
              end;

        {continue monitoring any data until ESC is pressed}
        until sdata=#27;
   end;
end;


{***********************************************************************}
procedure testport_via_library;
label labas,rep1,rep2;

var
   ia,ib,ic,id,portno,portno2:integer;
   baud,ca,rdata,sdata:char;
   baudrate:longint;

begin

{this procedure will do a loopback test using the PCCOM library
before proceeding be sure there is a loopback connector attached
to the specified port}
clrscr;
textcolor(14+blink);gotoxy(20,2);
writeln('D E C I S I O N    P R O D U C T S');
textcolor(11);gotoxy(30,3);
writeln('Serial Cards');
rep1:
for ia:=1 to 15 do
    begin
         textcolor(7);
         gotoxy(ia,5);writeln('Enter the COM port that would Send the data:          ');delay(30);
         textcolor(0);
         gotoxy(ia,5);writeln('Enter the COM port that would Send the data:          ');
    end;
textcolor(7);
{ask the user on which COM port the communication must be established}
gotoxy(ia,5);write('Enter the COM port that would Send the data: ');
readln(portno);

if not(cominstalled(portno)) then
begin
sound(500);
delay(200);
nosound;
goto rep1;
end;

rep2:
for ia:=1 to 15 do
    begin
         textcolor(7);
         gotoxy(ia,6);writeln('Enter the COM port that would Receive the data:         ');delay(30);
         textcolor(0);
         gotoxy(ia,6);writeln('Enter the COM port that would Receive the data:         ');
    end;
textcolor(7);
{ask the user on which COM port the communication must be established}
         gotoxy(ia,6);write('Enter the COM port that would Receive the data: ');
readln(portno2);

if not(cominstalled(portno2)) then
begin
sound(500);
delay(200);
nosound;
goto rep2;
end;

gotoxy(2,9);writeln('=======BAUD RATES=======');
gotoxy(2,11);writeln('    [0] - 600 kbps');
gotoxy(2,12);writeln('    [1] - 1200 kbps');
gotoxy(2,13);writeln('    [2] - 2400 kbps');
gotoxy(2,14);writeln('    [3] - 4800 kbps');
gotoxy(2,15);writeln('    [4] - 9600 kbps');
gotoxy(2,16);writeln('    [5] - 38400 kbps');
gotoxy(2,17);writeln('    [6] - 56000 kbps');
gotoxy(2,18);writeln('    [7] - 115200 kbps');
gotoxy(2,19);writeln('    [ESC] - Quit');
gotoxy(2,20);write('Enter Baud Rate to be used: ');baud:=readkey;

gotoxy(2,9);writeln('                                 ');
gotoxy(2,11);writeln('                               ');
gotoxy(2,12);writeln('                      ');
gotoxy(2,13);writeln('                      ');
gotoxy(2,14);writeln('                      ');
gotoxy(2,15);writeln('                      ');
gotoxy(2,16);writeln('                      ');
gotoxy(2,17);writeln('                      ');
gotoxy(2,18);writeln('                      ');
gotoxy(2,19);writeln('                      ');
gotoxy(2,20);writeln('                                    ');

if baud='0' then baudrate:=B600 else
if baud='1' then baudrate:=B1200 else
if baud='2' then baudrate:=B2400 else
if baud='3' then baudrate:=B4800 else
if baud='4' then baudrate:=B9600 else
if baud='5' then baudrate:=B38400 else
if baud='6' then baudrate:=B56000 else
if baud='7' then baudrate:=B115200 else
if baud=#27 then goto labas;


textcolor(15);
gotoxy(2,9);writeln('Data being Send !!!');
gotoxy(2,10);Writeln('------------------------------------------------------------------------------');
gotoxy(2,18);writeln('Data being Read !!!');
gotoxy(2,19);Writeln('------------------------------------------------------------------------------');

{initialize the specified port}
cominit(portno,baudrate,CS8,PNONE,ST1);
cominit(portno2,baudrate,CS8,PNONE,ST1);




{this is a standard to enable the proper communication of the computer;
in hardware terms the COMSETMCR(portno,8), enables the OUT2 signal of the
corresponding port. See hardware manual of the UART IC for more description. }

comsetmcr(portno,8);
comsetmcr(portno2,8);

{clear the receive buffer of the specified port for any garbage data}
compurgerxbuf(portno);
compurgerxbuf(portno2);
ia:=2;
ib:=2;
ic:=11;
id:=20;
repeat
      sdata:=chr(random(20)+60);
      if ia=79 then
      begin
           ia:=2;
           if ic=15 then
           begin
            ic:=11;
            gotoxy(2,11);writeln('                                                                                ');
            gotoxy(2,12);writeln('                                                                                ');
            gotoxy(2,13);writeln('                                                                                ');
            gotoxy(2,14);writeln('                                                                                ');
            gotoxy(2,15);writeln('                                                                                ');
            sound(400);delay(10);nosound;
           end
           else ic:=ic+1;

      end;
      if ib=79 then
      begin
           ib:=2;
           if id=24 then
           begin
           id:=20;
           gotoxy(2,20);writeln('                                                                                ');
           gotoxy(2,21);writeln('                                                                                ');
           gotoxy(2,22);writeln('                                                                                ');
           gotoxy(2,23);writeln('                                                                                ');
           gotoxy(2,24);write('                                                                                ');
           end
           else id:=id+1;
      end;

      {send the randomly generated data from the specified port
      to the receive buffer}
      comtxch(portno,sdata);

      {get the data from the receive buffer, then display the sent and
      received data}
      comrxch(portno2,rdata);
      gotoxy(ia,ic);write(sdata);
      gotoxy(ib,id);write(rdata);
      ia:=ia+1;ib:=ib+1;

until keypressed;
ca:=readkey;
labas:
end;


{************************************************************************}
procedure menu2;
label e_menu;

var
tres:char;

begin
if response='2' then
   {this goes to the procedure that uses the PCCOM library  for loopback test}
   begin
        testport_via_library;
        goto e_menu;
   end;
if response='3' then
   {this goes to the procedure that uses the PCCOM library for computer to computer test}
   begin
        test_computer_to_computer;
        goto e_menu;
   end;

{this is to ask the user on what card the loopback test would be done}
repeat
      clrscr;
      textcolor(14+blink);gotoxy(20,5);
      writeln('D E C I S I O N    P R O D U C T S');
      textcolor(11);gotoxy(30,6);
      writeln('Serial Cards');
      textcolor(15);
      gotoxy(20,10);writeln('[ ] PC COM 2 Port RS422/RS485 Card');
      gotoxy(20,11);writeln('[ ] PC COM ISA 2 Port RS-232 Card');
      gotoxy(20,12);writeln('[ ] PC COM 4 Port RS-232 Card');
      gotoxy(20,13);writeln('[ ] PC COM 4 Port RS-422 Card');
      gotoxy(20,14);writeln('[ ] PC COM 4 Port ISA Bus RS-232 Card');
      gotoxy(20,15);writeln('[ ] PC COM 8 Port RS-232/422 Card');
      gotoxy(20,16);writeln('[ ] PC COM ISA Bus 8 Port RS-232/422 Card');
      gotoxy(20,17);writeln('[ ] RISCOM 4/8 Port RISC CPU Intelligent RS-232/422 Card');
      gotoxy(20,18);writeln('[ ] Easy COM 8*4 Intelligent RS-232 Card');
      gotoxy(20,19);writeln('[ ] Quit');
      textcolor(13);
      gotoxy(21,10);writeln('1');
      gotoxy(21,11);writeln('2');
      gotoxy(21,12);writeln('3');
      gotoxy(21,13);writeln('4');
      gotoxy(21,14);writeln('5');
      gotoxy(21,15);writeln('6');
      gotoxy(21,16);writeln('7');
      gotoxy(21,17);writeln('8');
      gotoxy(21,18);writeln('9');
      gotoxy(21,19);writeln('0');
      response2:=readkey;
      tres:=response;
      if (response2='1')and(response='1') then p1 else
      if (response2='2')and(response='1') then p2 else
      if (response2='3')and(response='1') then p3 else
      if (response2='4')and(response='1') then p4 else
      if (response2='5')and(response='1') then p5 else
      if (response2='6')and(response='1') then p6 else
      if (response2='7')and(response='1') then p6 else
      if (response2='8')and(response='1') then p8 else
      if (response2='9')and(response='1') then p9 else
      if (response2='0')and(response='1') then delay(1)
      else
      {if invalid key was pressed create a beep}
      begin
           sound(500);delay(300);nosound;
      end;
      response:=tres;
until response2='0';

e_menu:
end;

{*********************************************************************}
procedure phelp;
begin
clrscr;
textcolor(14+blink);gotoxy(20,2);writeln('<<<<<<<<<<<<<< Help Option >>>>>>>>>>>>>');
textcolor(15);
gotoxy(1,4);write('*Direct Port Address Programming - ');
textcolor(7);
write('this is the procedure that tests the card     using direct hardware programming. ');
write('The presetted I/O address of the card is     used as a reference for Serial Communication.');
textcolor(15);
gotoxy(1,8);write('*PCCOM Library - ');
textcolor(7);
write('this is the procedure that tests the card using the PCCOM       library included in the source disk. ');
writeln('The procedure uses the standard INT 14     for Serial Communication.');
writeln;
writeln(' You can customize the type of loopback test you want:');
writeln(' e.g. Port 1: for sending data, Port 2: for receiving data');
writeln;
writeln(' In normal loopback, just specify the same port for sending and receiving data:');
writeln(' e.g. Port 5: for sending data, Port 5: for receiving data');
writeln;
writeln('NOTE: dont forget to attach the proper loopback connector for the type of');
writeln('      loopback you wish to test');


textcolor(15);
gotoxy(1,21);write('*Computer to Computer Communication - ');
textcolor(7);
write('this is the routine that communicates with a remote computer by using the PCCOM library. ');
write('The remote computer should also   have loaded the PCCOM driver and is running this same program.');
textcolor(15+blink);gotoxy(25,25);write('Press any key to continue !!!');
response:=readkey;
end;


{==============================MAIN PROGRAM===============================}
begin
     repeat
           clrscr;
           textcolor(14+blink);gotoxy(20,5);
           writeln('D E C I S I O N    P R O D U C T S');
           textcolor(11);gotoxy(30,6);
           writeln('Serial Cards');
           textcolor(7);
           gotoxy(25,9);writeln('Choose the kind of test');
           textcolor(15);
           gotoxy(20,10);writeln('[ ] using Direct Port Address Programming');
           gotoxy(20,11);writeln('[ ] using PCCOM Library ');
           gotoxy(20,12);writeln('[ ] using Computer to Computer Communication');
           gotoxy(20,13);writeln('[ ] HELP');
           gotoxy(20,14);writeln('[ ] Quit Program');
           textcolor(13);
           gotoxy(21,10);writeln('1');
           gotoxy(21,11);writeln('2');
           gotoxy(21,12);writeln('3');
           gotoxy(21,13);writeln('4');
           gotoxy(21,14);writeln('5');
           response:=readkey;
           if response in ['1'..'3'] then menu2
           else
           if response='4' then phelp
           else
           if response='5' then goto finish
           else
           {if key pressed was invalid make a beep}
           begin
                sound(500);delay(300);nosound;
           end;
     until response='5';

finish:

{this is to return the defualt color of the text and background}
textcolor(7);
textbackground(0);
clrscr;
end.