/*
 * PCCOM transmit program    By Decision-Computer   Aug. 93'
 */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#include "comlib.h"

/*
 * global variables used in rx.c
 */
int _comtxecho = 0,
    _comrxecho = 0;

int _comtxch(int portno, char ch)
{
   int rtn;

   rtn = comtxch(portno, ch);
   if (!(rtn & 0x8000)) { // no time out
      if (_comtxecho) {
	 putch(ch);
	 if (ch == 10) putch(13);
	 if (ch == 13) putch(10);
      }
      rtn = 0;
   }

   return rtn;
}

int _comrxch(int portno, char *ch)
{
   int tmp, rtn;

   rtn = comrxch(portno, ch);
   if (_comrxecho) {
      tmp = _comtxecho;
      _comtxecho = 0;
      _comtxch(portno, *ch);
      _comtxecho = tmp;
   }
   if (!(rtn & 0x80)) rtn = 0;

   return rtn;
}

void _comsetecho(int te, int re)
{
   _comtxecho = te;
   _comrxecho = re;
}

void err(int n, char *p)
{
   puts(p);
   exit(n);
}

void main(int argc, int *argv[])
{
  int comport = 4,emode = 0,remote = 0;

  char *help =
"  Use : TX (/PnLR)\n\
	 Pn = port number  L = Local echo  R = Remote echo\n\
	default : /P1\n\
  Example : TX \n\
  Example : TX /P6L < FILE.DOC\n";

   int i;
   char ch, *p;

   if (argc != 1 && argc != 2) err(0, help);

   if (argc == 2) {
      for (p = argv[1]; *p != '\0'; p++) {
	 switch (*p) {
	    case 'p' :
	    case 'P' :
	       comport = *(++p) - '0';
	       break;
	    case 'l' :
	    case 'L' :
	       emode = 1;
	       break;
	    case 'r' :
	    case 'R' :
	       remote = 1;
	       break;
	    case '/' :
	       break;
	    default  :
	       err(1, help);
	       break;
	 }
      }
   }

   if (!cominstalled(comport)) {
      printf("PCCOM is not installed\n");
      exit(1);
   }

   if (comport < 0 || comport >= 64) err(3, help);

   _comsetecho(emode, 0);
   while ((ch = getchar()) != EOF) {
      while (_comtxch(comport, ch));
      if (remote && _comrxch(comport, &ch) == 0) putchar(ch);
   }
   _comtxch(comport, 26);

   delay(50);

   while (remote && _comrxch(comport, &ch) == 0) putchar(ch);

   exit(0);
}
