


                        Specifications of PCCOM V2.0


. Multiport Serial Driver

  - support multiple ports

  - provide well-defined software interface

  - configure easily automatically or manually

  - provide serial communication utilities

  - basic principles of BIOS call interface


. Support Multiple Ports

  - each serial port may be either 8250, 16450, or 16550(FIFO)

  - support multiple sets of serial ports (up to 8 sets)

  - each set owns one irq

  - one irq triggers either 1 port, 2 ports, 4 ports,
    8 ports, 16 ports, or 24 ports

  - therefore, support serial ports up to 64 ports

  - each set can operated in vectorized or polling mode


. Provide Well-Defined Software Interface

  - provide both BIOS and DOS Device Driver interface to use the
    serial commuications facilities

  - provide high-level libraries helpful to sophisticated programming
    % for C, Pascal, Basic


. Configure easily Automatically or Manually

  - based on simple rules to configure multiple sets

  - configuring rule

    Config := /B:Bios_no /D:Dos_name /A:Pccom

    Bios_no := dec_value

    Dev_name := Dev_strDev_no, Dev_name      [note : length(Dev_name) <= 8]
             := Dev_name

       Dev_str := ([a..z] | [A..Z]))*

       Dev_no := 1..99

    Pccom := Com_irq, Pccom
          := Com_irq
          := nil

    Com_irq := [Irq:Com_set]

    Com_set := Com_vect:Com_set
            := Com_vect
            := nil

    Com_vect := Base,Portno,Vector,Active:Com_port

    Com_port := Port, Com_port
             := Port
             := nil

    Port := (Buf_siz:Baud_rate:Line_control:Modem_control:Flow_control)
         := (Buf_siz:Baud_rate:Line_control:Modem_control:Flow_control)
            * dec_value

    Irq := 2 | 3 | 4 | 5 | 6 | 7 | 10 | 11 | 12 | 14 | 15


    Base := hex_value

    Portno := 1 | 2 | 4 | 8

    Vector := hex_value | 0

    Active := HI | LO

    Buf_siz := dec_value k
            := dec_value
            := nil

    Baud_rate := dec_value

    Line_control := Parity-Data-Stop

       Parity := E | O | N

       Data :=  5 | 6 | 7 | 8

       Stop := 1 | 2

    Modem_control := Mc+Modem_control
                  := Mc
                  := nil

       Mc = DTR | RTS | OUT1 | OUT2

    Flow_control := Fc+Flow_control
                 := Fc
                 := nil

       Fc = DTR | RTS | XON

    Comment := # string         [a whole line comment]


  - one set of 4 ports

    /B:4                [bios port no = 4, 5, 6, 7]

    /D:COM5             [dos device name = COM5, COM6, COM7, COM8]

    /A:[5:
          2A0,4,2BF,LO:
                       (1k :9600:N-8-1:RTS+OUT2:XON),
                       (512:9600:N-8-1:DTR+OUT1:),
                       (256:9600:N-8-1:DTR:XON),
                       (128:9600:N-8-1::XON)]


  -  one set of 8 ports

    /B:0                [bios port no = 0, 1, 2, 3, 4, 5, 6, 7]

    /D:COM5, COM10      [dos device name = COM5,  COM10, COM11, COM12
                                           COM13  COM14, COM15, COM16]

    /A:[5:
          280,8,2C2,LO:
                       (1k:4800:E-7-2:DTR+RTS:DTR) * 4,
                       (2k:4800:N-8-1:DTR+RTS:XON) * 4]

  - one set of 16 ports

    /B:8                [bios port no =  8,  9, 10, 11, 12, 13, 14, 15,
                                        16, 17, 18  19, 20, 21, 22, 23]

    /D:COM1, COM3, COMM2      [dos device name = COM1,   COM3,
                                                 COMM2,  COMM3,  COMM4,  COMM5
                                                 COMM6,  COMM7,  COMM8,  COMM9
                                                 COMM10, COMM11, COMM12, COMM13
                                                 COMM14, COMM15]
    /A:[5:
          280,8,2C2,LO:
                       (1k:2400:N-8-1:DTR+RTS:RTS),
                       (1k:2400:N-8-1:DTR+RTS:RTS),
                       (1k:2400:N-8-1:DTR+RTS:RTS),
                       (1k:2400:N-8-1:DTR+RTS:RTS),
                       (1k:2400:N-8-1:DTR+RTS:DTR) * 4 :
          180,8,1C2,LO:
                       (1k:2400:N-8-1:DTR+RTS:XON) * 8]

  - two sets of 8 ports

    /A:[5:
          280,8,2C2,LO:
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON)]
    /A:[7:
          180,8,1C2,LO:
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1:DTR+RTS:XON),
                       (1k:1200:N-8-1::XON) * 2,
                       (1k:1200:N-8-1:DTR+RTS:) * 2]


  - Some Contraints on Configuration Rule

    % The size of total buffer in one Com_set must be less than 64K.
      However, the size of total buffer used in driver can be larger
      than 64K.

    % The number of ports in one Com_set must matchs the number of
      Com_ports in the following definition.

    % The maximum size of the buffer allocated for one port is 32K, but
      The maximum size of the buffer allocated for one set is 64K.

    % In Com_port definition, buffer size, baud rate, and line control
      must be specified, both modem control and flow control could be
      not specified if you do not want these capabilities, however the
      separator ":" can not be skipped.


  - How to install and configure PCCOM driver

    % The PCCOM driver that is DOS-style driver is installed when system
      boots by means of inserting the following line in config.sys

          DEVICE=C:\PCCOM\PCCOM.SYS @c:\PCCOM\pccom.opt

      The content of the file "pccom.opt" is configuration rule specified;
      the character '@' must be prefixed with the configuration file.


. Provide Serial Communication Utilities

  - terminal emulators
    % VT52

  - setup utilities
    % setup for pccom driver

  - diagnostic utilities

  - file transfer utilities

  - examples


. Basic Calling convention of PCCOM BIOS Call

  - int 14h : replace the builtin BIOS serial comm. functions

  - how to call

    AH : func. no.

    DX : port no.


. PCCOM BIOS Functions

  - Function 00h - Set communications parameters, baud, parity etc.

    Input:    AH = 00h
              AL = Communications parameters (defined below)
              DX = Port number

              Output:   AX = Port status (see function 03h)

    This  function is identical to  the IBM PC  BIOS call except that
    110 baud and 150 baud have been replaced by 19200  baud and 38400
    baud respectively.  The high order  3 bits of AL specify the baud
    rate  as  follows:

              010 =   300 baud
              011 =   600  ''
              100 =  1200  ''
              101 =  2400  ''
              110 =  4800  ''
              111 =  9600  ''
              000 = 19200  '' (Replaces IBM 110 baud setting)
              001 = 38400  '' (Replaces IBM 150 baud setting)

    The low order 5 of AL specify the following:

              Bits 4-3 define parity:       0 0  no parity
                                            1 0  no parity
                                            0 1  odd parity
                                            1 1  even parity

              Bit 2 defines stop bits:      0    1 stop bit;
                                            1    1.5 bits for 5-bit codes,
                                                 2 for others

              Bits 1-0 character length:    0 0  5 bits
                                            0 1  6 bits
                                            1 0  7 bits
                                            1 1  8 bits


  - Function 01h - Transmit character and wait.

    Input:    AH = 01h
              AL = Character
              DX = Port number

    Output:   AX = Port status (see function 03h)

    Upon  entry to this function, AL must contain a character that is
    to be transmitted.   If there is room in the transmit buffer, the
    character  buffered.   Otherwise, this  function will  loop until
    their is  room in the buffer or until  a timeout occurs.  If set,
    the high  order bit of  the returned status indicates  a time out
    occurred.   See function 03h.   At the time of  this writing, the
    timeout is set to 3 seconds.


  - Function 02h - Get received character with wait.

    Input:    AH = 02h
              DX = Port number

    Output:   AH = Line status (same AH returned by function 3)
              AL = Input character

    If a  character available  in the  receive buffer, this  function
    returns the next character from the  receive buffer in AL.  If no
    receive character is available, this function return immediately.


  - Function 03h - Return Serial Port Status.

    Input:    AH = 03h
              DX = Port number

    Output:   AX = Status bits as follows:

              AH = Line Status, where:
                   Bit 0 = RDA  - input data is available in buffer
                   Bit 1 = OVRN - the input buffer has been overrun
                   Bit 2 = Reserved (Parity error in BIOS INT 14h)
                   Bit 3 = Reserved (Framing error in BIOS INT 14h)
                   Bit 4 = Reserved (Break detect in BIOS INT 14h)
                   Bit 5 = THRE - room is available in output buffer
                   Bit 6 = TSRE - output buffer is empty
                   Bit 7 = Timeout (set by functions 1 and 2 only)

     Bit 7 of AH IS ALWAYS ZERO WHEN RETURNED BY FUNCTION 3.  Bit 7 of
     AH may be  set to one by other functions (like 1 and 2) that also
     return status.  When bit 7 of AH is set to one, none of the other
     15 bits returned in AX are valid.

              AL = Modem status, where:
                   Bit 0 = Delta clear to send (not reliable)
                   Bit 1 = Delta data set ready (not reliable)
                   Bit 2 = Delta data carrier detect (not reliable)
                   Bit 3 = Always set to 1 upon return (DUMMY DCD)
                   Bit 4 = Clear to send (CTS)
                   Bit 5 = Data set ready (DSR)
                   Bit 6 = Ring indicator (RI)
                   Bit 7 = Data carrier detect (DCD)

     Bit  3  of AL  is  always  returned  set  to  1.    This  enables
     application programs  to use  bit 3  as a  carrier detect bit  on
     hardwired (null modem) links.


  - Function 04h - Activate Port.

    Input:    AH = 04h
              DX = port number

    Output:   AX = 1954h if successful
              BL   =  maximum  function  number  supported  (not
                      counting functions 7Eh and above)
                      BH = rev of FOSSIL specification supported

    This function will detect the physical port assoicated with  port
    number in DX firstly,  Then DTR turned on by this function.  The
    baud rate is NOT set or changed by this function.


  - Function 05h - Deactivate Port.

    Input:    AH = 05h
              DX = Port number

    Output:   Nothing

    Nothing to do in this function.


  - Function 06h - Raise/lower DTR.

    Input:    AH = 06h
              AL = DTR state to set
              DX = Port number

    Output:   Nothing

    This function is used to control the DTR signal.   AL = 00h means
    lower DTR (turn it off), and AL = 01h means to raise DTR (turn it
    on).  No other function (except functions 04h and 1Ch) will alter
    DTR.


  - Function 07h - Return timer tick information.

    Input:    AH = 07h

    Output:   AL = Timer tick interrupt number
              AH = Approximate interrupts per second (18 on IBM)
              DX = Approximate number of milliseconds per tick

    This  function  is used  to determine  the characteristic  of the
    timer tick for the computer.

    Application  programs  can  use  information  returned  by   this
    function to dynamically  set up  code that is  executed on  every
    timer tick.


  - Function 08h - Flush output buffer. (Not Supported)

    Input:    AH = 08h
              DX = Port number

    Output:   Nothing


  - Function 09h - Purge output buffer. (Not Supported)

    Input:    AH = 09h
              DX = Port number

    Output:   Nothing

    This function  is used to  remove any buffered  output (transmit)
    data.   Any  output  data remaining  in  the output  buffer  (not
    transmitted yet) is discarded.


  - Function 0Ah - Purge input buffer.

    Input:    AH = 0Ah
              DX = Port number

    Output:   Nothing

    This function is  used to  remove any  buffered input  (received)
    data.    Any  input data  which  is  in  the  receive  buffer  is
    discarded.


  - Function 0Bh - Transmit no wait. (Function same as Function 01H)

    Input:    AH = 0Bh
              AL = Character
              DX = Port number

    Output:   AX = 0001h - Character was buffered for xmit
              AX = 0000h - Character was not buffered

    This is exactly  the same as  function 01h.


  - Function 0Ch - Non-destructive read-ahead (Peek).

    Input:    AH = 0Ch
              DX = Port number

    Output:   AH = 00h if character is available
              AL = Next character if available
              AX = 0FFFFh = If no character is available

    This function returns the next character from the receive buffer.
    If the  receive buffer is empty,  0FFFFh is returned in  AX.  The
    character   returned  remains   in  the   receive   buffer.  Some
    programmers call this function "peek".


  - Function 0Dh - Keyboard read without wait. (Not Supported)

    Input:    AH = 0Dh

    Output:   AX = IBM-style scan code if available
                 = 0FFFFh if no character not available


  - Function 0Eh - Keyboard read with wait. (Not Supported)

    Input:    AH = 0Eh

    Output:   AX = Keyboard scan code


  - Function 0Fh - Flow Control for serial I/O.

    Input:    AH = 0Fh
              AL = Bit defining the flow control to use
              DX = Port number

    Output:   Nothing

    Two kinds of basic flow control are supported.  One is  software,
    called  Xon/Xoff  flow control.   The  other is  hardware, called
    RTS/CTS  or  DTR/DSR  flow  control.  Both  software and hardware
    flow control may be enabled at the same time.

    The bits in the parameter passed in AL are as follows:

                   Bit 0 = 1      Enable receiving of Xon/Xoff
                   Bit 1 = 1      Enable RTS/CTS flow control

                   Bit 2 = 1      Enable DTR/DSR flow control
                   Bit 3 = 1      Enable transmitting of Xon/Xoff

    Setting  an appropriate bit to  zero will cause  the flow control
    associated with that bit to be disabled.

    Enabling  the  receiving  of  Xon/Xoff  will  cause PCCOM to stop
    transmitting   upon  receiving   an  Xoff.     PCCOM will  resume
    transmitting when an Xon is received.

    Enabling the sending of Xon/Xoff will cause PCCOM to send an Xoff
    when its buffers are 3/4  full.  When the buffers are  emptied to
    1/4 full, PCCOM will send an Xon.

    PCCOM Will cease  transmitting when CTS  IS lowered. Transmission
    will  Resume  when  CTS  is  raised, if  RTS  in modem control is
    enabled.  However, the  RTS  can't be set up in modem control and
    flow at same time.

    When RTS/CTS flow control is  enabled, PCCOM will  drop (turn off)
    RTS when  the receive buffer is  3/4 full. PCCOM will raise (turn
    on) RTS  when the  receive buffer empties  to 1/4 full.   RTS/CTS
    flow control is almost  always used by modems that  operate above
    2400  baud.    Some  2400  baud  modems  also  use/allow  RTS/CTS
    handshaking.

    DTR/DSR flow control is the same as  DTS/CTS  except substituting
    DTR for RTS, DSR for CTS.


  - Function 10h - Control-C  /  Control-K  checking and  transmitter
    disable/enable. (Not Supported)

    Input:    AH = 10h
              AL = Control bits (defined below)
              DX = Port number

    Output:   AX = 0001h - A Control-C/K has been received
                 = 0000h - A Control-C/K has not been received


  - Function 11h - Set current cursor location. (Not Supported)

    Input:    AH = 11h
              DH = Row (line)
              DL = Column

    Output:   Nothing


  - Function 12h - Read current cursor location. (Not Supported)

    Input:    AH = 12h

    Output:   DH = Row (line)
              DL = Column


  - Function 13h - Single character ANSI write to screen. (Not Supported)

    Input:    AH = 13h
              AL = Character to display

    Output:   Nothing


  - Function 14h - Enable or disable the DCD watchdog. (Not Supported)

    Input:    AH = 14h
              AL = 01h - Enable watchdog
                 = 00h - Disable watchdog
              DX = Port number

    Output:   Nothing


  - Function 15h - Write character to screen using BIOS. (Not Supported)

    Input:    AH = 15h
              AL = Character to display

    Output:   Nothing


  - Function 16h - Add or delete a routine from the timer tick chain. (Not Supported)

    Input:    AH = 16h
              AL = 01h - Add a function
                 = 00h - Delete a function
              ES = Segment of function
              DX = Offset of function

    Output:   AX = 0000h - Operation successful
                 = FFFFh - Operation unsuccessful


  - Function 17h - Reboot system. (Not Supported)

    Input:    AH = 17h
              AL = 00h - "Cold boot"
                 = 01h - "Warm boot"

    Output:   Nothing


  - Function 18h - Block Read.

    Input:    AH = 18h
              CX = Requested number of characters to transfer
              DX = Port number
              ES = Segment of the caller's buffer
              DI = Offset of the caller's buffer

    Output:   AX = Number of characters actually transferred

    This function will transfer from 0 to 65534 characters from PCCOM's
    inbound ring  buffer to  the caller's  buffer. ES:DI  are not
    changed by  this function.   The  number of  bytes placed  in the
    caller's buffer is  returned in AX.   The  number returned in  AX
    will be the lesser of the caller's requested amount or the entire
    contents (if any) of PCCOM's receive buffer.


  - Function 19h - Block Write.

    Input:    AH = 19h
              CX = Requested number of characters to transfer
              DX = Port number
              ES = Segment of the caller's buffer
              DI = Offset of the caller's buffer

    Output:   AX = Number of characters actually transferred

    This function will transfer directly from 0 to  65534  characters
    to UART's transmission buffer. ES:DI  are  not  changed  by  this
    function. The number of bytes Transmitted by PCCOM is returned in
    AX.


  - Function 1Ah - Break begin or end.

    Input:    AH = 1Ah
              AL = 01h - Start sending 'break'
                 = 00h - Stop sending 'break'
              DX = port number

    Output:   Nothing

    This function will  start or terminate a break signal.  If AL=01h
    PCCOM  will start the  transmission  of a break.  If AL=00h PCCOM
    will terminate  any  break  signal. This  function  is useful for
    activating command mode on some modems.  The  application program
    is responsible  for the timing  of the  BREAK.


  - Function 1Bh - Return information about PCCOM.

    Input:    AH = 1Bh
              CX = Size of caller's info buffer in bytes
              DX = Port number
              ES = Segment of caller's info buffer
              DI = Offset of caller's info buffer

    Output:   AX = Number of bytes actually transferred

    This  function  will transfer  information  about  PCCOM  and its
    current status  to the  caller.   This  function  is intended  to
    assist "generic" applications to adjust to the current environment.

    The data structure  (assembly language style)  currently returned
    by PCCOM is as follows:

         INFO      EQU  $              ;DEFINE BEGIN OF STRUCTURE
         STRSIZ    DW   INFO_SIZE      ;SIZE OF THIS STRUC IN BYTES
         MAJVER    DB   CURR_FOSSIL    ;FOSSIL SPECIFICATION REV
         MINVER    DB   CURR_REV       ;REV OF THIS DRIVER.
         IDENT     DD   ID_STRING      ;"FAR" POINTER TO ASCIIZ
                                       ; DRIVER DESCRIPTION STRING.
         IBUFR     DW   IBSIZE         ;BYTE SIZE OF THE INPUT BUFFER
         IFREE     DW   ?              ;NUMBER OF BUFFERED RECV BYTES
         OBUFR     DW   OBSIZE         ;BYTE SIZE OF THE XMIT BUFFER
         OFREE     DW   ?              ;NUMBER OF BUFFERED XMIT BYTES
         SWIDTH    DB   SCREEN_WIDTH   ;WIDTH OF DISPLAY SCREEN
         SHEIGHT   DB   SCREEN_HEIGHT  ;HEIGHT OF DISPLAY SCREEN
         BAUD      DB   ?              ;BAUD RATE, COMPUTER TO MODEM

    The IDENT  string  is null-terminated,  and  does not  contain  a
    newline.  The baud rate byte contains  the bits that Function 00h
    would use to set the port to that speed.


  - Function 30h - Get buffer status.

    Input:    AH = 30h
              DX = Port number

    Output:   CX = Number of characters in buffer
                 = FFFFh - overflow


  - Function 31h - Set port address.

    Input:    AH = 31h
              DX = Port number
              BX = Port address

    Output:   Nothing


  - Function 32h - Set vector address.

    Input:    AH = 32h
              DX = Port number
              BX = Vector address

    Output:   Nothing


  - Function 33h - Set active status in vector.

    Input:    AH = 33h
              DX = Port number
              AL = 0 - LO
                 = 1 - HI

    Output:   Nothing


  - Function 34h - Set modem control.

    Input:    AH = 34h
              DX = Port number
              AL = Modem control value (see below)

    Output:   Nothing

              AL =
                   bit 7 - 0
                       6 - 0
                       5 - 0
                       4 - Loopback
                       3 - Out2
                       2 - Out1
                       1 - RTS
                       0 - DTR


  - Function 35h - Get port parameters.

    Input:    AH = 35h
              DX = Port number

    Output:   AL = port parameters (see Function 00h)


  - Function 36h - Get modem control value.

    Input:    AH = 36h
              DX = Port number

    Output:   AL = Modem control value (see Function 34h)


  - Function 37h - Get flow control value.

    Input:    AH = 37h
              DX = Port number

    Output:   AL = Flow control value (see Function 09h)


  - Function 38h - Get the total number of PCCOM sets

    Input:    AH = 38h

    Output:   AX = Total number of pccom sets


  - Function 39h - Get information about each PCCOM set

    Input:   AH    = 39h
             DL    = set number - less than returned number of func 13h
             ES:DI = pointer to space containing set information (see below)
                     , the size of this buffer space is 55(7 + 6 * 8).

    Output:  AX = number of bytes returned in buffer point by ES:DI

        Data structure :
           irq          db              ;interrupt request
           portno       dw              ;total number of ports in this set
           groupno      dw              ;total number of groups in this set
           whichgroup   dw              ;specified port in which group

           base         dw              ;base address for this com set
           vector       dw              ;interrupt vector address
           active       db              ;active hi or lo in vector
           portno       db              ;total number of ports in this com set
             :           :                          :
             :           :                          :
           base         dw              ;base address for this com set
           vector       dw              ;interrupt vector address
           active       db              ;active hi or lo in vector
           portno       db              ;total number of ports in this com set

        represented in C:

           typedef struct {
              unsigned char irq;
              unsigned int  portno;
              unsigned int  groupno;
              unsigned int  whichgroup

              struct {
                 unsigned int  base;
                 unsigned int  vector;
                 unsigned char active;
                 unsigned char portno;
              } group[8];
            } BiosComSet_t;


  - Function 3Ah - Get the total number of PCCOM sets.

    Input:    AH = 3Ah

    Output:   AX = Total number of pccom ports


  - Function 3Bh - Detect one pccom port to determine whether the port is
                   existent or not

    Input:    AH = 3Bh
              DX = Port number

    Output:   AX = 55AA : this port exists
                   0    : this port is not existent

    You must assure that there is no transmission happened through the port
    that you want to detect, otherwise this function call maybe corrupts the
    transmission, or causes the port not to work.


  - Function 3Ch - Get information of one PCCOM port.

    Input:    AH = 3Ch
              DX = Port number
              ES:DI = pointer to space containing port information (see below)

    Output:   AX = the number of bytes returned in buffer pointer by ES:DI,
                   the size of this buffer space is 13.

        Data structure :
           addr         dw              ;port address
           baud_rate    dw              ;baud rate
           lcr          db              ;line control register value
           mcr          db              ;modem control regsiter value
           fc           db              ;flow control protocol
           q_sz         dw              ;rx ring buffer size
           q_free       dw              ;free space in ring buffer
           rx_enable    db              ;flag to notify the port receivable
           tx_enable    db              ;flag to notify the port transmissive


        Represented in C:

           typedef struct {
              unsigned int  addr;
              unsigned int  baud;
              unsigned char lcr;
              unsigned char mcr;
              unsigned char fc;
              unsigned char rx_qsz;
              unsigned int  rx_qfree;
              unsigned char rx_enable;
              unsigned char tx_enable;
           } BiosComPort_t;


  - Function 3Dh - Notify peer to stop sending data

    Input:    AH = 3Dh
              DX = Port number

    Output:   Nothing


  - Function 3Eh - Notify peer to restart sending data

    Input:   AH = 3Eh
             DX = Port number

    Output:  Nothing


  - Function 3FH - Set time-out value of sending out char with waiting

    Input:   AH = 3Fh
             DX = Port number
             CX = time-out value in unit of 1/18 sec.

    Output:  Nothing


  - Function 40H - Get time-out value of sending out char with waiting

    Input:   AH = 3Fh
             DX = Port number

    Output:  CX = time-out value in unit of 1/18 sec.


. PCCOM DOS IOCTL Input functions

  - This is DOS system call IOCTL to the PCCOM character device.

    Input:    AH    = 44H
              AL    = 02H
              BX    = handle number
              CX    = number of bytes to transfer
              DS:DX = segment:offset of data buffer (viewed as control block)

    Output:
              If function is successful:

                 Carry flag is clear.

                 AX    = number of bytes to transfer.

                 Data buffer at DS:DX contains data read from device driver.

              If function is not successful:

                 Carry flag is set.

                 AX    = error code:
                         01H    invalid function
                         05H    access denied
                         06H    invalid handle
                         0DH    invalid data (bad control block)


    The transfer address(DS:DX) points to a control block that is used to
    communicate with the device driver. The first byte of the control block
    determines the request that is being made.

                Number of Bytes
    Code        to Transfer          Function

    0           3                    get serial port status
    1           3                    get port communication parameters
    2           3                    get modem control value
    3           3                    get flow control value
    4           3                    get the size of available data in rx buffer


  - Get Serial Port Status

    PortSts     db      0               ;control block code
                db      ?               ;serial port status
                db      ?               ;not used

    The format of serial port status is referred to BIOS function 03H.


  - Get Port Setting

    PortParam   db      1               ;control block code
                db      ?               ;port communication parameters
                db      ?               ;not used

    The format of serial port setting parameters is referred to BIOS function
    00H.


  - Get Modem Control Value

    PortMC      db      2               ;control block code
                db      ?               ;modem control value
                db      ?               ;not used

    The format of modem control value is referred to BIOS function 36H.


  - Get Flow Control Value

    PortFC      db      3               ;control block code
                db      ?               ;flow control value
                db      ?               ;not used

    The format of flow control vlaue is referred to BIOS function 0FH.


  - Get the Size of Available data in RX Buffer

    PortRXData  db      4               ;control block code
                dw      ?               ;available data size in rx buffer


. PCCOM DOS IOCTL Output functions

  - This is DOS system call IOCTL to the PCCOM character device.

    Input:    AH    = 44H
              AL    = 03H
              BX    = handle number
              CX    = number of bytes to transfer
              DS:DX = segment:offset of data buffer (viewed as control block)

    Output:
              If function is successful:

                 Carry flag is clear.

                 AX    = number of bytes to transfer.

              If function is not successful:

                 Carry flag is set.

                 AX    = error code:
                         01H    invalid function
                         05H    access denied
                         06H    invalid handle
                         0DH    invalid data (bad control block)


    The transfer address(DS:DX) points to a control block that is used to
    communicate with the device driver. The first byte of the control block
    determines the request that is being made.

                Number of Bytes
    Code        to Transfer          Function

    0           2                    set port communication parameters
    1           2                    set modem control value
    2           2                    set flow control value
    3           2                    turn on/off "break"
    4           2                    purge rx buffer


  - Set Port Communication Parameters

    PortParam   db      0               ;control block code
                db      XX              ;port communication parameters

    This function is the same as BIOS function 00H.


  - Set Modem Control Value

    PortMC      db      1               ;control block code
                db      XX              ;modem control value

    This function is the same as BIOS function 34H.


  - Set Flow Control Value

    PortFC      db      2               ;control block code
                db      XX              ;flow control value

    This function is the same as BIOS function 0FH.


  - Turn on/off "BREAK"

    PortFC      db      2               ;control block code
                db      XX              ; 1 : start sending 'break'
                                          0 : stop sendinf 'break'

    This function is the same as BIOS function 1AH.


  - Purge in RX Buffer

    PortRXData  db      4               ;control block code
                db      ?               ;not used

    This function is the same as BIOS function 0AH.


. PCCOM Interface

  1. cominit

     DESCRIPTION
        set communication parameters

     SYNOPSIS
        int cominit(int portno, unsigned int baud, int db, int parity, int sb);

     PARAMETERS
        portno          port number that defined in configuration file

        baud            B38400 (38400)  --      38400 baud
                        B19200 (19200)  --      19200 baud
                        B9600  (9600)   --      9600  baud
                        B4800  (4800)   --      4800  baud
                        B2400  (2400)   --      2400  baud
                        B1200  (1200)   --      1200  baud
                        B600   (600)    --      600   baud
                        B300   (300)    --      300   baud

        db              data bits
                        CS8 (8)         --      8 bits
                        CS7 (7)         --      7 bits
                        CS6 (6)         --      6 bits
                        CS5 (5)         --      5 bits

        parity          parity bit
                        PNONE (0)       --      none parity check
                        PODD  (1)       --      odd parity
                        PEVEN (2)       --      even parity

        sb              stop bits
                        ST1 (1)         --      one stop bits
                        ST2 (2)         --      two stop bits

     RETURN VALUE
        0               success
        1               fail


  2. comtxch

     DESCRIPTION
        send a character to serial port

     SYNOPSIS
        int comtxch(int portno, char c);

     PARAMETERS
        portno          port number

        c               transmitted char

     RETURN VALUE
        0               success
        1               fail


  3. comrxch

     DESCRIPTION
        receive a character

     SYNOPSIS
        int comrxch(int portno, char *c);

     PARAMETERS
        portno          port number

        c               received car

     RETURN VALUE
        0               success
        1               fail (receive no character)


  4. comstat

     DESCRIPTION
        get serial port status

     SYNOPSIS
        int comstat(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        bit             being set
        15              timeout error
        14              transmitter shift register empty
        13              transmitter holding register empty
         8              data ready (data available in input buffer)
         7              received line signal detect (RLSD)
         5              data set ready (DSR)
         4              clear to send (CTS)

        you may check the following constants to detect which bit is set.
        S_TIMEOUT       0x8000
        S_TSRE          0x4000
        S_THRE          0x2000
        S_RDA           0x0100
        S_DCD           0x0080
        S_DSR           0x0020
        S_CTS           0x0010


  5. comactive

     DESCRIPTION
        check if the port is active

     SYNOPSIS
        int comactive(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        1               active
        0               inactive


  6. comsetDTR

     DESCRIPTION
        set DTR signal line ON or OFF

     SYNOPSIS
        void comsetDTR(int portno, int dtr);

     PARAMETERS
        portno          port number

        dtr             ACITVE (1)      --      set DTR ON
                        INACTIVE (0)    --      set DTR OFF

     RETURN VALUE
        none


  7. compurgerxbuf

     DESCRIPTION
        remove any buffered input (received) data

     SYNOPSIS
        void compurgerxbuf(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        none


  8. compeek

     DESCRIPTION
        perform nondestructively read a character; the read character still in
        the receive buffer

     SYNOPSIS
        int compeek(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        0xFFFF          no character
           ?            received character


  9. comsetflow

     DESCRIPTION
        set communication protocol

     SYNOPSIS
        void comsetflow(int portno, int flow);

     PARAMETERS
        portno          port number

        flow            F_XONXOF (0x09)         set XON/XOFF protocol
                        F_RTSCTS (0x01)         set CTS/RTS protocol

     RETURN VALUE
        none


  10. comrxblk

     DESCRIPTION
        receive a block of data

     SYNOPSIS
        int comrxblk(int portno, void *ptr, int size);

     PARAMETERS
        portno          port number

        ptr             pointer to data block received

        size            block length

     RETURN VALUE
        number of characters received


  11. comtxblk

     DESCRIPTION
        transmit a block of data

     SYNOPSIS
        int comtxblk(int portno, void *ptr, int size);

     PARAMETERS
        portno          port number

        ptr             pointer to data block transmitted

        size            block length

     RETURN VALUE
        number of characters sent


  12. combreak

     DESCRIPTION
        send the break signal to peer

     SYNOPSIS
        void combreak(int portno, int brk);

     PARAMETERS
        portno          port number

        brk             ACTIVE (1)      --      break the communication
                        INACTIVE (0)    --      unbreak the communication

     RETURN VALUE
        none

  13. cominstalled

     DESCRIPTION
        check if the driver is installed for this port

     SYNOPSIS
        int cominstalled(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        1               installed
        0               not installed


  14. comtxs

     DESCRIPTION
        send one string to serial port by calling BIOS for each character

     SYNOPSIS
        int comtxs(int portno, char *s);

     PARAMETERS
        portno          port number

        s               one character string to be sent

     RETURN VALUE
        0               success
        1               fail


  15. comrxs

     DESCRIPTION
        get one string from received buffer by calling BIOS for each character

     SYNOPSIS
       int comrxs(int portno, char *s);

     PARAMETERS
        portno          port number

        s               the pointer to the received string

     RETURN VALUE
        0               success
        1               fail


  16. combufstat

     DESCRIPTION
        return number of characters in receive buffer

     SYNOPSIS
        int combufstat(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        0xFFFF          buffer overflow
        otherwise       number of characters in receive buffer


  17. comsetport

     DESCRIPTION
        set address of some serial port

     SYNOPSIS
        void comsetport(int portno, int addr);

     PARAMETERS
        portno          port number

        addr            serial port address

     RETURN VALUE


  18. comsetvector

     DESCRIPTION
        set interrupt vector to one interrupt line for this port

     SYNOPSIS
        void comsetvector(int portno, int addr);

     PARAMETERS
        portno          port number

        addr            interrupt vector address that is designed at adapter

     RETURN VALUE
        none


  19. comactive

     DESCRIPTION
        set interrupt vector that is active low or high

     SYNOPSIS
        void comsetactive(int portno, char active);

     PARAMETERS
        portno          port number

        active          0       --      active low
                        1       --      active high

     RETURN VALUE
        none


  20. comsetMCR

     DESCRIPTION
        set the contents of modem control register

     SYNOPSIS
        void comsetMCR(int portno, int mcr);

     PARAMETERS
        portno          port number

        mcr             modem control register
                        bit
                          7 - 0
                          6 - 0
                          5 - 0
                          4 - Loopback
                          3 - Out2
                          2 - Out1
                          1 - RTS
                          0 - DTR

     RETURN VALUE
        none

  21. comgetinfo

     DESCRIPTION
        get communication parameters of specified port

     SYNOPSIS
        void comgetinfo(int portno, unsigned int *baud, int *db, int *parity,
                        int *sb);

     PARAMETERS
        portno          port number

        baud            baud rate (see cominit)

        db              data bits (see cominit)

        parity          parity bit (see cominit)

        sb              stop bits (see cominit)

     RETURN VALUE
        none


  22. comgetMCR

     DESCRIPTION
        get the value of modem control register of specified port

     SYNOPSIS
        char comgetMCR(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        modem control value (see comsetMCR)


  23. comgetFC

     DESCRIPTION
        get the communication protocol of specified port

     SYNOPSIS
        char comgetFC(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        flow control value (see comsetflow)


  24. comgetsets

     DESCRIPTION
        get the number of PCCOM set controlled by the PCCOM driver;

     SYNOPSIS
        int comgetsets(void);

     PARAMETERS
        none

     RETURN VALUE
        number of PCCOM set


  25. comgetsetinfo

     DESCRIPTION
        get the PCCOM set information about specified PCCOM port that belongs
        to this set;

        the structure of BiosComSet_t as follows
           typedef struct {
              unsigned char irq;        // irq number for this set
              unsigned int  portno;     // number of serial ports in this set
              unsigned int  groupno;    // number of groups in this set
                                        // each group corresponding to serial
                                           ports with the same interrupt vector
              unsigned int  whichgroup  // the specified port belonging to
                                           which group among ones

              struct {
                 unsigned int  base;    // the base address for serial ports
                                           in this group
                 unsigned int  vector;  // interrupt vector address
                 unsigned char active;  // active status in interrupt vector
                 unsigned char portno;  // the number of ports in this group
              } group[8];
            } BiosComSet_t;

     SYNOPSIS
        BiosComSet_t *comgetsetinfo(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        the content about the PCCOM set to which the specified port belongs


  26. comgetports

     DESCRIPTION
        get the number of PCCOM ports controlled by the PCCOM driver

     SYNOPSIS
        int comgetports(void);

     PARAMETERS
        none

     RETURN VALUE
        the number of PCCOM ports


  27. comdetectport

     DESCRIPTION
        detect if the specified serial port is existent or not

     SYNOPSIS
        int comdetectport(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        1               existent
        0               not existent


  28. comgetportinfo

     DESCRIPTION
        retrieve all information about one specified PCCOM port;
        the content of information as follows:

        typedef struct {
           unsigned int  addr;          ;port address
           unsigned int  baud;          ;baud rate
           unsigned char lcr;           ;line control register value
           unsigned char mcr;           ;modem control regsiter value
           unsigned char fc;            ;flow control protocol
           unsigned char rx_qsz;        ;rx ring buffer size
           unsigned int  rx_qfree;      ;free space in rx ring buffer
           unsigned char rx_enable;     ;flag to notify the port receivable
           unsigned char tx_enable;     ;flag to notify the port transmissive
        } BiosComPort_t;

     SYNOPSIS
        BiosComPort_t *comgetportinfo(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        the content of inoformation about one PCCOM port


  29. comrxoff

     DESCRIPTION
        notify the peer that is connected with the specified serial port to
        stop sending data

     SYNOPSIS
        void comrxoff(int portno);

     PARAMETERS
        portno          port number which peer connected to

     RETURN VALUE
        none

  30. comrxon

     DESCRIPTION
        notify the peer that is connection with the specified serial port to
        restart sending data

     SYNOPSIS
        void comrxon(int portno);

     PARAMETERS
        portno          port number which peer connected to

     RETURN VALUE
        none


  31. comsettimout

     DESCRIPTION
        set the timeout value about tx; when transmitter buffer in the
        specified port is full, the driver will wait until buffer empty or
        the timeoout value is expired.

     SYNOPSIS
        void comsettimeout(int portno, unsigned int timeout);

     PARAMETERS
        portno          port number

        timeout         timeout value whose unit is 1/18 sec.

     RETURN VALUE
        none


  32. comgettimeout

     DESCRIPTION
        get the tx timeout value about the specified port

     SYNOPSIS
        unsigned int comgettimeout(int portno);

     PARAMETERS
        portno          port number

     RETURN VALUE
        the timeout value whose unit is 1/18 sec.


