#ifndef _COMDOS_H
#define _COMDOS_H

#define IOCTLGETSTAT            0x00
#define IOCTLGETPARAM           0x01
#define IOCTLGETMC              0x02
#define IOCTLGETFC              0x03
#define IOCTLGETDATASZ          0x04

typedef unsigned int  PortSts_t;
typedef unsigned char PortParam_t;
typedef unsigned char PortMC_t;
typedef unsigned char PortFC_t;
typedef unsigned int  PortBufSz_t;

typedef struct {
           char cbc;            //control block code
           union {
              PortSts_t      PortSts;        //serial port status : 0x00
              PortParam_t    PortParam;      //port setting : 0x01
              PortMC_t       PortMC;         //modem control : 0x02
              PortFC_t       PortFC;         //flow control : 0x03
              PortBufSz_t    PortRxDataSz;   //data size in rx buffer size : 0x04
          } cb;         //parameter block
        } IOCTLIN_t;

#define IOCTLSETPARAM           0x00
#define IOCTLSETMC              0x01
#define IOCTLSETFC              0x02
#define IOCTLSETBREAK           0x03
#define IOCTLPURGERXBUF         0x04

typedef unsigned char PortBreak_t;

typedef struct {
           char cbc;         //control block code

           union {
              PortParam_t PortParam;            //set communication param : 0x00
              PortMC_t    PortMC;               //set modem control : 0x01
	      PortFC_t    PortFC;               //set flow control : 0x02
              PortBreak_t PortBreak;            //set on/off break : 0x03
	   } cb;
	} IOCTLOUT_t;

int  ioctlstat(int h);
char ioctlgetparam(int h);
void ioctlgetinfo(int h, unsigned int *baud, int *db, int *parity, int *sb);
char ioctlgetMCR(int h);
char ioctlgetFC(int h);
int  ioctlbufstat(int h);
int  ioctlinit(int h, unsigned int baud, int db, int parity, int sb);
void ioctlsetMCR(int h, int mc);
void ioctlsetflow(int h, int fc);
void ioctlbreak(int h, int brk);
void ioctlpurgebuf(int h);

#endif _COMDOS_H
