/*
 * dterm.c - ascii terminal for RS232 communication
 */
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <bios.h>

#define END     26

void main(int argc, char *argv[])
{
   FILE *dvp;
   int  dvno;
   char tch, rch;

   if (argc<2) {
      puts("Usage : ascterm [devicename] < [input] > [output]");
      puts("Example :");
      puts("   ascterm com1");
      puts("   ascterm com8 > abc.doc");
      puts("   ascterm mydriver < abc.doc");
      return;
   }

   dvp = fopen(*(argv+1), "rb+");
   if (dvp == NULL) {
      puts("No such device.");
      return;
   }

   puts("SERIAL DRIVER Communication Ascii Terminal V2.0");
   puts("Type ^Z to stop communication.");

   dvno = fileno(dvp);
   do {
      while (bioskey(1) == 0)
	 if (read(dvno, &rch,1 ) != 0) putchar(rch);
	 tch = getch();
	 write(dvno,&tch,1);
      } while (tch != END);
      fclose(dvp);
}