/* the COMLIBBC.C file contains all the PCCOM library functions,
the PCDIAGM1.CPP file contains the functions for the direct
hardware loopback test.
 */

# include <stdio.h>
# include <conio.h>
# include <stdlib.h>
# include <comli460.c>
# include <pcdiagm1.cpp>

char response,response2;
int data,result,counter3;


/***********************************************************************/
/*
NOTE: This same program must be executed on the remote computer simultaneously
with this computer.

This is the procedure that tests the computer to computer communication.
When the procedure is executed it sends a continous signal in the form of
the character 'S' to the remote computer then waits for the remote computer
to send its own signal. When it receives the signal from the remote computer
it would be now ready to receive any data that the remote computer sends.
At the same time it is ready to accept any keyboard input from the user
then sends this data to the remote computer.
*/

void test_computer_to_computer()

{
	int portno,ia,ib,ic,id,evaluate;
	char rdata,sdata;


clrscr();
textcolor(14 | BLINK);gotoxy(25,2);
cprintf("D E C I S I O N   P R O D U C T S");
textcolor(11);gotoxy(30,3);
cprintf("Computer to Computer Test");

for (ia=1; ia!=15; ia++)
{
	textcolor(7);
	gotoxy(ia,5);cprintf("Enter the COM port that would Send/Receive the data:");
	delay(30);
	textcolor(0);
	gotoxy(ia,5);cprintf("Enter the COM port that would Send/Receive the data:");
}

textcolor(7);

/* ask the user on which COM port the communication must be established*/
gotoxy(ia,5);cprintf("Enter the COM port that would Send/Receive the data:");
scanf("%d",&portno);

/*initialize the specified COM port*/
cominit(portno,B9600,CS8,PNONE,ST1);

/*this is a standard to enable the proper communication of the computer,
in hardware terms the comsetMCR(portno,8), enables the OUT2 signal of the
corresponding port. See hardware manual of the UART IC for more description */
comsetMCR(portno,8);

/*this is to clear the receiver buffer of the specified port for any garbage data */
compurgerxbuf(portno);
gotoxy(2,9);cprintf("Data being Send !!!");
gotoxy(2,10);cprintf("--------------------------------------------------------------");
gotoxy(2,18);cprintf("Data being Read !!!");
gotoxy(2,19);cprintf("--------------------------------------------------------------");
textcolor(4 | BLINK);
gotoxy(2,7);cprintf("Waiting for Remote Computer to respond !!!");

do{
	/*this is the signal transmitted to ask a request for communication */
	comtxch(portno,'S');

	/*receive any request from the remote PC */
	comrxch(portno,&rdata);
	delay(100);
	if ((kbhit()) | (rdata=='S')) evaluate=1; else evaluate=0;
}while (evaluate!=1);

/*if the remote computer also sends a request for communication then
we start communicating */
if (rdata=='S')
{
	textcolor(0);
	gotoxy(2,7);cprintf("Waiting for Remote Computer to Respond !!!");
	textcolor(15);
	gotoxy(2,7);cprintf("You may now type your Message !!!");

	/*clear again the receive buffer of the specified port */
	compurgerxbuf(portno);
	ia=2;
	ib=2;
	ic=11;
	id=20;

	do {
		if (ia==79)
		{
			ia=2;
			if (ic==18) ic=11; else ic=ic+1;
		}
		if (ib==79)
		{
			ib=2;
			if (id==24) id=20; else id=id+1;
		}
		do {

			/*this is to check if there are any pending data in the
			receive buffer, the command below returns  the number
			of data still in the receive buffer */
			result=combufstat(portno);
			if ((kbhit()) | (result!=0)) evaluate=1; else evaluate=0;
		} while (evaluate==0);
		if (kbhit())
		{
			sdata=getch();
			if (sdata!=27)
			{
				/*transmit the data the user wish to send */
				comtxch(portno,sdata);
				gotoxy(ia,ic);putch(sdata);
				ia=ia+1;
			}
		}
		if (result != 0)
		{
			/*get the data in the receive buffer, then display it */
			comrxch(portno,&rdata);
			gotoxy(ib,id);putch(rdata);
			ib=ib+1;
		}
	/*continue monitoring any data until ESC is pressed */
	} while (sdata!=27);
}
}


/***********************************************************************/
void testport_via_library()
{

	int ia,ib,ic,id,portno,portno2,evaluate;
	char ca,rdata,sdata;

/*this procedure will do a loopback test using the PCCOM library
before proceeding be sure there is a loopback connector attached
to the specified port */
clrscr();
textcolor(14 | BLINK); gotoxy(20,2);
cprintf("D E C I S I O N   P R O D U C T S");
textcolor(11);gotoxy(30,3);
cprintf("Serial Cards");

/*rep1:*/
for (ia=1; ia!=16; ia++)
{
	textcolor(7);
	gotoxy(ia,5); cprintf("Enter the COM port that would Send the data: ");delay(30);
	textcolor(0);
	gotoxy(ia,5); cprintf("Enter the COM port that would Send the data: ");
}

textcolor(7);

/*ask the user on which COM port the communication must be established */
gotoxy(ia,5);cprintf("Enter the COM port that would Send the data: ");
scanf("%d",&portno);

/*if (!(cominstalled(portno)))
{
sound(500);
delay(200);
nosound();
goto rep1;
}*/

for (ia=1; ia!=16; ia++)
{
	textcolor(7);
	gotoxy(ia,6); cprintf("Enter the COM port that would Receive the data: ");delay(30);
	textcolor(0);
	gotoxy(ia,6); cprintf("Enter the COM port that would Receive the data: ");
}

textcolor(7);

/*ask the user on which COM port the communication must be established */
gotoxy(ia,6);cprintf("Enter the COM port that would Receive the data: ");
scanf("%d",&portno2);

textcolor(15);
gotoxy(2,9);cprintf("Data being Send !!!");
gotoxy(2,10);cprintf("----------------------------------------------------");
gotoxy(2,18);cprintf("Data being Read !!!");
gotoxy(2,19);cprintf("----------------------------------------------------");

/*initialize the specified port */
cominit(portno,B9600,CS8,PNONE,ST1);
cominit(portno2,B9600,CS8,PNONE,ST1);

/*this is a standard to enable the proper communication of the computer,
in hardware terms the comsetMCR(portno,8), enables the OUT2 signal of the
corresponding port. See hardware manual of the UART IC for more description */
comsetMCR(portno,8);
comsetMCR(portno2,8);

/*clear the receive buffer of the specified port for any garbage data */
compurgerxbuf(portno);
compurgerxbuf(portno2);

ia=2;
ib=2;
ic=11;
id=20;

do{
	sdata=(random(20)+60);
	if (ia==79)
	{
		ia=2;
		if (ic==16) ic=11; else ic=ic+1;
	}

	if (ib==79)
	{
		ib=2;
		if (id==25) id=20; else id=id+1;
	}

	/*send the randomly generated data from the specified port
	to the receive buffer */
	comtxch(portno,sdata);

	/*get the data from the receive buffer, then display the sent and
	received data */
	comrxch(portno2,&rdata);
	gotoxy(ia,ic);putchar(sdata);
	gotoxy(ib,id);putchar(rdata);delay(100);
	ia=ia+1; ib=ib+1;

}while (!kbhit());
if (kbhit()) getch();

}


/*************************************************************************/
void menu2()
{
	char tres;


if (response=='2')
{

	/*this goes to the subroutine that uses the PCCOM library for loopback test */
	testport_via_library();
	goto e_menu;
}

if (response=='3')
{

	/*this goes to the subroutine that uses the PCCOM library for computer to computer test */
	test_computer_to_computer();
	goto e_menu;
}

/*this is to ask the user on what card the loopback test would be done*/
do{
	clrscr();
	textcolor(14 | BLINK); gotoxy(20,5);
	cprintf("D E C I S I O N   P R O D U C T S");
	textcolor(11); gotoxy(30,6);
	cprintf("Serial Cards");
	textcolor(15);
	gotoxy(20,10);cprintf("[ ] PC COM 2 Port RS422/RS485");
	gotoxy(20,11);cprintf("[ ] PC COM ISA 2 Port RS-232");
	gotoxy(20,12);cprintf("[ ] PC COM 4 Port RS-232");
	gotoxy(20,13);cprintf("[ ] PC COM 4 Port RS-422");
	gotoxy(20,14);cprintf("[ ] PC COM 4 Port ISA Bus RS-232 Card");
	gotoxy(20,15);cprintf("[ ] PC COM 8 Port RS-232/422 Card");
	gotoxy(20,16);cprintf("[ ] PC COM ISA Bus 8 Port RS-232/422 Card");
	gotoxy(20,17);cprintf("[ ] RISCOM 4/8 Port RISC CPU Intelligent RS-232/422 Card");
	gotoxy(20,18);cprintf("[ ] Easy COM 8*4 Intelligent RS-232 Card");
	gotoxy(20,19);cprintf("[ ] Quit");
	textcolor(13);
	gotoxy(21,10);cprintf("1");
	gotoxy(21,11);cprintf("2");
	gotoxy(21,12);cprintf("3");
	gotoxy(21,13);cprintf("4");
	gotoxy(21,14);cprintf("5");
	gotoxy(21,15);cprintf("6");
	gotoxy(21,16);cprintf("7");
	gotoxy(21,17);cprintf("8");
	gotoxy(21,18);cprintf("9");
	gotoxy(21,19);cprintf("0");
	response2=getch();

	if (response2=='1') p1();
	if (response2=='2') p2();
	if (response2=='3') p3();
	if (response2=='4') p4();
	if (response2=='5') p5();
	if (response2=='6') p6(6);
	if (response2=='7') p6(7);

}while (!(response2=='0'));


e_menu:
}

/*************************************************************************/
void phelp()
{

clrscr();
textcolor(14|BLINK);gotoxy(20,2);cprintf("<<<<<<<<<<<< Help Option >>>>>>>>>>>>>");
textcolor(15);
gotoxy(1,4);cprintf("*Direct Port Address Programming - ");
textcolor(7);
cprintf("this is the procedure that tests the card     using direct hardware programming. ");
cprintf("The presetted I/O address of the card is     used as a reference for Serial Communication.");
textcolor(15);
gotoxy(1,8);cprintf("*PCCOM Library - ");
textcolor(7);
cprintf("this is the procedure that tests the card using the PCCOM       library included in the source disk. ");
cprintf("The procedure uses the standard INT 14     for Serial Communication");
cprintf("\n \n \r You can customize the type of loopback test you want: ");
cprintf("\n \r e.g. Port 1: for sending data, Port 2: for receiving data");
cprintf("\n \n \r In normal loopback, just specify the same port for sending and receiving data:");
cprintf("  e.g. Port 5: for sending data, Port 5: for receiving data");
cprintf("\n \n \rNOTE: don't forget to attach the proper loopback connector for the type of");
cprintf("\n \r      loopback you wish to test");
textcolor(15);
gotoxy(1,21);cprintf("*Computer to Computer Communication - ");
textcolor(7);
cprintf("this is the routine that communicates with a remote computer by using the PCCOM library. ");
cprintf("The remote computer should also   have loaded the PCCOM driver and is running this same program.");
textcolor(15 | BLINK);gotoxy(25,25);cprintf("Press any key to continue !!!");
response=getch();
}


/*===============================MAIN==================================*/
void main(void)
{

do {
	clrscr();
	textcolor(14 | BLINK);gotoxy(20,5);
	cprintf("D E C I S I O N   P R O D U C T S");
	textcolor(10);gotoxy(20,7);
	cprintf(" ** for HIGH SPEED Cards only **");
	textcolor(11);gotoxy(30,6);
	cprintf("Serial Cards");
	textcolor(7);gotoxy(25,9);
	cprintf("Choose the kind of test");
	textcolor(15);
	gotoxy(20,10);cprintf("[ ] using Direct Port Address Programming");
	gotoxy(20,11);cprintf("[ ] using PCCOM Library");
	gotoxy(20,12);cprintf("[ ] using Computer to Computer Communication");
	gotoxy(20,13);cprintf("[ ] HELP");
	gotoxy(20,14);cprintf("[ ] Quit Program");
	textcolor(13);
	gotoxy(21,10);cprintf("1");
	gotoxy(21,11);cprintf("2");
	gotoxy(21,12);cprintf("3");
	gotoxy(21,13);cprintf("4");
	gotoxy(21,14);cprintf("5");
	response=getch();
	if ((response=='1')|(response=='2')|(response=='3'))  menu2(); else
	if (response=='4') phelp(); else
	if (response=='5') goto finish; else
	{

		/*if key pressed was invalid make a beep */
		sound(500);delay(300);nosound();
	}
}while (response != '5');

finish:

/*this is to return the default color of the text and background*/
textcolor(7);
textbackground(0);
clrscr;
}